package examples;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.sql.rowset.CachedRowSet;

import com.sun.rowset.CachedRowSetImpl;

public class JDBCRowSetUpdate {
    public static void main(String args[]) {
        String url = "jdbc:derby://localhost:1527/java";
        String sqlStmt = "SELECT id, salary, title " 
                + "FROM employee "
                + "ORDER BY lastname";
        
        try (Connection conn = DriverManager.getConnection(url);
                Statement stmt = conn.createStatement();
                ResultSet rs = stmt.executeQuery(sqlStmt);
                CachedRowSet crs = new CachedRowSetImpl();) {
            
            crs.populate(rs);
            stmt.close();

            while (crs.next()) {
                if (!crs.getString("title").equals("Manager")) {
                    float oldSal = crs.getFloat("salary");
                    crs.updateFloat("salary", oldSal * 1.1f);
                }
                crs.updateRow();
            }
            crs.setTableName("employee");
            crs.acceptChanges(conn);
        }
        catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
