package examples;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Savepoint;
import java.sql.Statement;

public class JDBCSavepoint {
    public static void main(String args[]) {
        String url = "jdbc:derby://localhost:1527/java";
        String s1 = "UPDATE employee SET salary = salary * 1.1253";
        String s2 = "UPDATE employee SET title = 'CEO' WHERE id = 9683";
        try (Connection conn = DriverManager.getConnection(url);
                Statement stmt = conn.createStatement();) {

            conn.setAutoCommit(false);

            stmt.executeUpdate(s1);
            Savepoint sp = conn.setSavepoint("SVP1");
            stmt.executeUpdate(s2);

            conn.rollback(sp);
            conn.commit();
            stmt.close();
            conn.close();
        }
        catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }
}
